// OzDialogs.c
//


#include <string.h>
#include <stdio.h>

#include "TkOzAPI.h"
#include "OzAPI.h"


// different params to WINDOZE
void ozfilelistboxdlg_ (char* prompt, char* fileName, int* itemChosen, 
		  	char* text, 
			int promptSize, int fileNameSize, int textSize)

{
	int done = FALSE;
	char str[MAX_STRING];
	char name[MAX_STRING];
	char buff[MAX_STRING+1];
	FILE* fp;
	char* ptr;

	GnuParam(str, prompt, promptSize); // parameter
	GnuParam(name, fileName, fileNameSize); // parameter

	fp = fopen(name, "r");
	if (!fp)
	{
		*itemChosen = 0;
		strcpy(text, "OPEN ERROR");
		return;
	}


	strcpy(tclCmd, "OzListDlg \"Select from List\" ");

	strcat (tclCmd, "\"");
	strcat (tclCmd, str);  // prompt
	strcat (tclCmd, "\"");

	strcat(tclCmd, " { ");
	while (fgets(buff, MAX_STRING, fp))
	{
		strcat (tclCmd, " \"");
		ptr = strchr(buff, '\n');
		if (ptr)
			*ptr = '\0';
		//SquashString(buff, MAX_STRING);
		strcat(tclCmd, buff);
		strcat(tclCmd, "\"");
	}
	strcat(tclCmd, " }");
	fclose(fp);

	#ifdef DEBUG
	fprintf (stderr, "%s\n", tclCmd);
	#endif


	while (!done)
	{
		Et_EvalF(Et_Interp, tclCmd); 
		Et_EvalF(Et_Interp, "OzResults $ozResult"); 
		if (strlen(ozResult) > 0)
		{
			ptr = strchr(ozResult, ' ');
			if (ptr && sscanf(ozResult, "%d", itemChosen) == 1)
			{
				(*itemChosen)++;
				ptr++;
				strcpy(text, ptr);
				done = TRUE;
			}
		}
	}
	return;
}



// different params to WINDOZE

int ozlistboxdlg_ (char* prompt, char* items, int* numItems,
			int promptSize, int itemsSize)
{

	int result = 0;
	int done = FALSE;
	int i;
	char str[MAX_STRING];

	GnuParam(str, prompt, promptSize); // parameter

	strcpy(tclCmd, "OzListDlg \"Select from List\" ");

	strcat (tclCmd, "\"");
	strcat (tclCmd, str);  // prompt
	strcat (tclCmd, "\"");

	strcat(tclCmd, " { ");
	for (i=0; i<*numItems; i++)
	{
		strcat (tclCmd, " \"");
		GnuParam(str, &items[i*itemsSize], itemsSize);
		strcat(tclCmd, str);
		strcat(tclCmd, "\"");
	}
	strcat(tclCmd, " }");


	#ifdef DEBUG
	fprintf (stderr, "%s\n", tclCmd);
	#endif


	while (!done)
	{
		Et_EvalF(Et_Interp, tclCmd); 
		Et_EvalF(Et_Interp, "OzResults $ozResult"); 
		if (strlen(ozResult) > 0)
		{
			if (sscanf (ozResult, "%d", &result) == 1)
					done = TRUE;
		}
	}
	return(result+1);
}




int ozintdlg_ (char* prompt, int* min, int* max, int* initial, 
		int promptSize)
{

	int result;
	char str[MAX_STRING];
	int done = FALSE;


	GnuParam(str, prompt, promptSize); // parameter

	while (!done)
	{
		Et_EvalF(Et_Interp, 
		"OzValueDlg \"Enter Integer Value\" \"%s\" %d 5", 
		str, *initial); 
		Et_EvalF(Et_Interp, "OzResults $ozResult"); 

		if (strlen(ozResult) > 0)
		{
			if (sscanf (ozResult, "%d", &result) == 1)
				if (result >= *min && result <= *max)
					done = TRUE;
		}
		if (!done)
			sprintf (str, "Range %d to %d", *min, *max);
	}

	return(result);
}

float ozrealdlg_ (char* prompt, float* min, float* max, float* initial, int promptSize)
{

	float result;
	char str[MAX_STRING];
	int done = FALSE;


	GnuParam(str, prompt, promptSize); // parameter

	while (!done)
	{
		Et_EvalF(Et_Interp, 
		"OzValueDlg \"Enter Real Value\" \"%s\" %f 10", 
		str, *initial); 
		Et_EvalF(Et_Interp, "OzResults $ozResult"); 

		if (strlen(ozResult) > 0)
		{
			if (sscanf (ozResult, "%f", &result) == 1)
				if (result >= *min && result <= *max)
					done = TRUE;
		}
		if (!done)
			sprintf (str, "Range %f to %f", *min, *max);
	}

	return(result);
}


void ozstringdlg_ (char* prompt, char* text, int* length, 
			int promptSize, int textSize)
{

	char str[MAX_STRING];
	char txt[MAX_STRING];
	int done = FALSE;
	int i;


	GnuParam(str, prompt, promptSize); // parameter
	GnuParam(txt, text, textSize); // parameter

	while (!done)
	{
		Et_EvalF(Et_Interp, 
		"OzValueDlg \"Enter String\" \"%s\" \"%s\" %d", 
		str, txt, *length); 
		Et_EvalF(Et_Interp, "OzResults $ozResult"); 

		if (strlen(ozResult) > 0)
			done = TRUE;
	}

	strncpy(text, ozResult, *length);
	for (i=strlen(ozResult); i<*length; i++)
		text[i] = ' ';	
}


void oztextdlg_ (char* fileName, int fileNameSize)
{

	char name[MAX_STRING];


	GnuParam(name, fileName, fileNameSize); // parameter


	strcpy(tclCmd, "OzTextDlg ");
	strcat(tclCmd, name);
	Et_EvalF(Et_Interp, tclCmd); 
}


